/* eslint-disable no-console */
require("./got-useragent");
const MulticraftAPI = require("multicraft-api-node");
const delay = require("delay");

const MULTICRAFT_INTERVAL = 30000;

(async function() {
	const api = new MulticraftAPI({
		key: process.env.MULTICRAFT_ACCESS_KEY,
		url: process.env.MULTICRAFT_ADDRESS,
		user: process.env.MULTICRAFT_USERNAME
	});

	await api.clearServerLog({ id: 212706 });

	let res = await api.getServerStatus({ id: 212706 });

	if (res.data.status === "online") {
		await api.stopServer({ id: 212706 });
		await delay(MULTICRAFT_INTERVAL);

		res = await api.getServerStatus({ id: 212706 });
		while (res.data.status === "online") {
			console.log("Multicraft: Server status is online");
			await delay(MULTICRAFT_INTERVAL);
			res = await api.getServerStatus({ id: 212706 });
		}
	}

	let log = await api.getServerLog({ id: 212706 });
	while (!log.data.find(e => e.line.includes("[Multicraft] Server stopped"))) {
		console.log("Multicraft: Server exit is incomplete");
		await delay(MULTICRAFT_INTERVAL);
		log = await api.getServerLog({ id: 212706 });
	}

	await delay(2 * MULTICRAFT_INTERVAL);
	console.log(log.data.map(d => d.line).join("\n"));
	await api.clearServerLog({ id: 212706 });
	console.log("Multicraft: Server instance is offline");
})();
