/* eslint-env node, mocha */
const path = require("path");
const conf = require("../selenium.conf");
const fixture = require("./fixture.test");

const scriptStagingDomain = `https://cdn.jsdelivr.net/gh/SNDST00M/material-dynmap@staging%2F${conf.github.sha}`;
const userScriptUrl = `${scriptStagingDomain}/src/user.js`;
const electronScriptUrl = `${scriptStagingDomain}/src/electron.js`;

conf.capabilities.forEach(function(cap) {
	suite(`${cap.browserName} Tests`, function() {
		this.timeout(60000);
		test("./src/user.js", fixture.bind({
			capability: cap,
			pageLoadStrategy: "eager",
			resourceUrl: userScriptUrl,
			scriptName: "user.js"
		}));

		if (cap.browserName !== "Chrome") {
			return;
		}

		cap["goog:chromeOptions"] = {
			binary: path.resolve(__dirname, "../node_modules/electron-chromedriver/bin/chromedriver.exe")
		};
		test("./src/electron.js", fixture.bind({
			capability: cap,
			pageLoadStrategy: "eager",
			resourceUrl: electronScriptUrl,
			scriptName: "electron.js"
		}));
		delete cap["goog:chromeOptions"];
	});
});
